//+------------------------------------------------------------------+
//|                                                         mqtt.mqh |
//|                                                         JS Lopes |
//|                                                     any@mail.net |
//|            ********* WORK IN PROGRESS **********                 |
//| **** PART OF ARTICLE https://www.mql5.com/en/articles/12857 **** |
//+------------------------------------------------------------------+
#property copyright "JS Lopes"
#property link      "jslopes.bts@gmail.com"

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void GenFixedHeader(uint pkt_type, uchar& buf[], uchar& head[])
  {
   ArrayFree(head);
   ArrayResize(head, 2);
   head[0] = uchar(pkt_type);
//if(ArraySize(buf) > 0)
//  {
//   ArrayResize(buf,buf.Size(),100);
//  }
// Remaining Length
   uint x;
   x = ArraySize(buf);
   do
     {
      uint encodedByte = x % 128;
      x = (uint)(x / 128);
      if(x > 0)
        {
         encodedByte = encodedByte | 128;
        }
      head[1] = uchar(encodedByte);
     }
   while(x > 0);
  }
//+------------------------------------------------------------------+

enum ENUM_PKT_TYPE
  {
   CONNECT     =  1, // Connection request
   CONNACK     =  2, // Connect acknowledgment
   PUBLISH     =  3, // Publish message
   PUBACK      =  4, // Publish acknowledgment (QoS 1)
   PUBREC      =  5, // Publish received (QoS 2 delivery part 1)
   PUBREL      =  6, // Publish release (QoS 2 delivery part 2)
   PUBCOMP     =  7, // Publish complete (QoS 2 delivery part 3)
   SUBSCRIBE   =  8, // Subscribe request
   SUBACK      =  9, // Subscribe acknowledgment
   UNSUBSCRIBE =  10, // Unsubscribe request
   UNSUBACK    =  11, // Unsubscribe acknowledgment
   PINGREQ     =  12, // PING request
   PINGRESP    =  13, // PING response
   DISCONNECT  =  14, // Disconnect notification
   AUTH        =  15, // Authentication exchange
  };

//+------------------------------------------------------------------+
